﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DoubleBuffer {
    public partial class MainForm : Form {

        private Medo.Drawing.SecondaryBuffer _buffer = new Medo.Drawing.SecondaryBuffer();
        private Pen _pen = new Pen(SystemColors.WindowText);
        private Random _rnd = new Random();

        public MainForm() {
            InitializeComponent();
        }

        protected override void OnPaintBackground(PaintEventArgs e) {
            if (mnuUseBuffering.Checked) { //with buffering

                //do nothing - just swallow :)

            } else { //no buffering

                base.OnPaintBackground(e);

            }
        }

        protected override void OnPaint(PaintEventArgs e) {
            if (mnuUseBuffering.Checked) { //with buffering

                _buffer.BeginNewGraphics(this.ClientRectangle.Size, Color.White);
                _buffer.NewGraphics.Clear(SystemColors.Window);
                for (int i = 0; i < 200; ++i) {
                    int x1 = _rnd.Next(this.ClientRectangle.Width);
                    int y1 = _rnd.Next(this.ClientRectangle.Height);
                    int x2 = _rnd.Next(this.ClientRectangle.Width);
                    int y2 = _rnd.Next(this.ClientRectangle.Height);
                    _buffer.NewGraphics.DrawLine(this._pen, x1, y1, x2, y2);
                }
                _buffer.EndNewGraphics(e.Graphics);

            } else { //no buffering

                e.Graphics.Clear(SystemColors.Window);
                for (int i = 0; i < 200; ++i) {
                    int x1 = _rnd.Next(this.ClientRectangle.Width);
                    int y1 = _rnd.Next(this.ClientRectangle.Height);
                    int x2 = _rnd.Next(this.ClientRectangle.Width);
                    int y2 = _rnd.Next(this.ClientRectangle.Height);
                    e.Graphics.DrawLine(this._pen, x1, y1, x2, y2);
                }

            }
        }

        private void mnuInvalidate_Click(object sender, EventArgs e) {
            this.Invalidate();
        }

        private void mnuUseBuffering_Click(object sender, EventArgs e) {
            mnuUseBuffering.Checked = !mnuUseBuffering.Checked;
            this.Invalidate();
        }

    }
}